;
;
; 16   .
;
;
;
;
;**************************************************************************************************************
;  
;**************************************************************************************************************

.include 	"m32def.inc"		;  ATMega32


;==============================================================================================================
;   // RAM
;==============================================================================================================
;
;******************************************************************************
;  
;******************************************************************************

.def	Temp =R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			; 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24			;
; .def	wiretemp =R25			;    1-Wire (      )
; .def 	wireres	 = R2			;    r0...r15  (      )			




;******************************************************************************
; 
;******************************************************************************


.dseg     ;  



;******************************************************************************
; 
;******************************************************************************


; .EQU	Constanta_1= 0x3E8 		; 1000


;==============================================================================================================
;   // FLASH // 
;==============================================================================================================

.cseg	


;******************************************************************************
;  
;******************************************************************************	
	

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp reset				;  				



.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    



	ldi Temp, low(RAMEND)		;  
	out SPL, Temp
	ldi Temp, high(RAMEND)
	out SPH, Temp




;******************************************************************************
;  
;******************************************************************************


;         
;     ,        
;        


;	ldi Temp,0b00000000		;   "A" (0-, 1-)
;	out DDRB,Temp			; 00000000 - "" 




;	ldi Temp,0b00100000		;   "D" (0-, 1-)
;	out DDRD,Temp			; 0000000 - "" 
					 
		
			

;	ldi Temp,0b00100000		;  _1   "D" (   )
;	out PortD,Temp			; 



				
;******************************************************************************
;   
;******************************************************************************


;******************************************************************************
;   (     )
;******************************************************************************



;******************************************************************************
;  
;******************************************************************************			

RCALL	LCD_INIT			;   (  "LCD_INIT"     )



;	sei				;   
	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************



;*******************************************************************************
;   
;*******************************************************************************


; 

			
	LDI R16, 55			;   ''
	RCALL LCD_CHAR	

	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 49			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 52			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 42			;   ''
	RCALL LCD_CHAR			
		
																				
	LDI R16, 53			;   ''
	RCALL LCD_CHAR
		

	LDI R16, 78			;   '.'
	RCALL LCD_CHAR						
			

	





;*******************************************************************************
;   
;*******************************************************************************

Start_temp:



	RCALL Init_1W			;   (  "Init_1W"     )


	ldi R16, 0xCC			;  ROM - CMD_SKIP_ROM
	mov R0, R16			; (           )
	RCALL Send_1W			; 

	
	ldi R16, 0x44			;    (      -
	mov R0, R16			; -  _ )
	RCALL Send_1W			;      1-wire



;     1-Wire
;    _0,     
;  _1,    
;
;      


	Rcall Loop0			; 


	RCALL Init_1W			;   (  "Init_1W"     )


	ldi R16, 0xCC			;  ROM - CMD_SKIP_ROM
	mov R0, R16			; (           )
	RCALL Send_1W			; 



	ldi R16, 0xBE			;        _.
	mov R0, R16			; - CMD_R_SCRATCHPAD
	RCALL Send_1W			;      1-wire



	RCALL ReadBytes_1W		;          Buffer_1w.



	lds XL, buffer_1w		;  (  )   "X"   "buffer_1w" 
	lds XH, buffer_1w+1		; 






;    
;     

																
	LDI R18, 1			;(Y) 2  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


;  16  
;    X (XH:XL)

   
        rcall printhex16
    


rjmp Start_temp






;*******************************************************************************
;     16-   ( 2  )
;*******************************************************************************

;  16  
;    X (XH:XL)


printhex16: 


        mov r16 , XH
        rcall printhex
        mov r16 , XL
        rcall printhex
        ret 


;*******************************************************************************
;        Hex-
;*******************************************************************************

;     hex ,         
;  r16     


printhex: 
   
	push r16			 ;      (    )
	swap r16			 ;   ,      
	rcall printhex1			 ;       
	pop   r16			 ;    

printhex1:
    
	andi r16, 0x0f			 ;    ( )
	rcall lcd_char			 ;      
	ret   



;*******************************************************************************
;   (  1  )
;*******************************************************************************



Loop0:

	ldi Temp1,0
	ldi Temp2,0
	ldi Temp3,0


Loop:     

	dec Temp1
	brne Loop

	dec Temp2
	brne Loop

	dec Temp3
	brne Loop


ret


;*******************************************************************************
;  
;*******************************************************************************

.include "lcd5110rus.asm"		;   	

.include "DS1820.asm"			;     DS18B20
